using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;
using System.Drawing;
//Coded By Frank Xu Lei 18/2/2009
//Study the .NET Memory Management
//Garbage Collector ռԸݲҪʱйԴ
//GC֪ιйԴӡݿӡʡ
//йԴͷ⡣IDisposeӿ
//COMü
//C++ֶNew Delete
//VBԶ
namespace MemoryManagement
{
    //̳нӿIDisposableʵDisposeͷFrankClassDisposeʵԴ
    public class FrankClassWithDispose : IDisposable
    {
        private OdbcConnection _odbcConnection = null;
        
        //캯
        public FrankClassWithDispose()
        {
            if (_odbcConnection == null)
                _odbcConnection = new OdbcConnection();
            Console.WriteLine("FrankClassWithDispose has been created ...");
        }
        //Է
        public void DoSomething()
        {

            ////code here to do something
            return ;
        }
        //ʵDisposeͷűʹõԴ
        public void Dispose()
        {
            if (_odbcConnection != null)
                _odbcConnection.Dispose();
            Console.WriteLine("FrankClassWithDispose has been disposed...");
        }
    }
    //ûʵFinalize,GCFrankClassFinalizeʵԴGCʱֱӻ
    public class FrankClassNoFinalize
    {
        private OdbcConnection _odbcConnection = null;
        //캯
        public FrankClassNoFinalize()
        {
            if (_odbcConnection == null)
                _odbcConnection = new OdbcConnection();
            Console.WriteLine("FrankClassNoFinalize  has been created...");
        }
        //Է
        public void DoSomething()
        {

            //GC.Collect();
            ////code here to do something
            return ;
        }
    }
    //ʵΪFinalizeö
    //GCʱεãһûͷԴڶβͷ
    //FrankClassDestructorʵԴ
    //CLRʹöִ߳жFinalize,Ƶûʹ½
    public class FrankClassWithDestructor
    {
        private OdbcConnection _odbcConnection = null;
        //캯
        public FrankClassWithDestructor()
        {
            if (_odbcConnection == null)
                _odbcConnection = new OdbcConnection();
            Console.WriteLine("FrankClassWithDestructor  has been created...");
        }
        //Է
        public void DoSomething()
        {
            ////code here to do something

            return ;
        }
        //,ͷδйԴ
        ~FrankClassWithDestructor()
        {
            if (_odbcConnection != null)
                _odbcConnection.Dispose();
            Console.WriteLine("FrankClassWithDestructor  has been disposed...");
        }
    }
   
}
