using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
//Coded By Frank Xu Lei 18/2/2009
//Study the .NET Memory Management
//Garbage Collector ռԸݲҪʱйԴ
//GC֪ιйԴӡݿӵ
//йԴͷ⡣IDisposeӿ
//COMü
//C++ֶNew Delete
//VBԶ
namespace MemoryManagement
{
    //̳нӿIDisposableʵDisposeͷFrankClassDisposeʵԴ
    public class FrankClassWithDispose : IDisposable
    {
        private SqlConnection _sqlConnection = null;
        //캯
        public FrankClassWithDispose()
        {
 
        }
        //Է
        public string TestMethod()
        {
            //if (_sqlConnection == null)
            //    _sqlConnection = new SqlConnection();
            ////code here to do something
            //if (_sqlConnection != null)
            //    _sqlConnection.Dispose();
            return "FrankClassWithDispose have already created  an new object...";
        }
        //ʵDisposeͷԴ
        public void Dispose()
        {
            if (_sqlConnection != null)
                _sqlConnection.Dispose();
        }
    }
    //ûʵFinalize,GCFrankClassFinalizeʵԴGCʱֱӻ
    public class FrankClassNoFinalize
    {
        private SqlConnection _sqlConnection = null;
        //캯
        public FrankClassNoFinalize()
        {
 
        }
        //Է
        public string TestMethod()
        {
            //if (_sqlConnection == null)
            //    _sqlConnection = new SqlConnection();
            ////code here to do something
            //if (_sqlConnection != null)
            //    _sqlConnection.Dispose();
            return "FrankClassNoFinalize have already created  an new object...";
        }
    }
    //ʵΪFinalizeö
    //GCʱεãһûͷԴڶβͷ
    //FrankClassDestructorʵԴ
    //CLRʹöִ߳жFinalize,Ƶûʹ½
    public class FrankClassWithDestructor
    {
        private SqlConnection _sqlConnection = null;
        //캯
        public FrankClassWithDestructor()
        {
 
        }
        //Է
        public string TestMethod()
        {
            //if (_sqlConnection==null)
            //    _sqlConnection = new SqlConnection();
            ////code here to do something
            //if (_sqlConnection != null)
            //    _sqlConnection.Dispose();
            return "FrankClassWithDestructor have already created  an new object...";
        }
        //,ͷԴ
        ~FrankClassWithDestructor()
        {
            //_sqlConnection.Dispose();
        }
    }
    public class FrankClassWithUsing 
    {
        private SqlConnection _sqlConnection = null;
        //캯
        public FrankClassWithUsing()
        {

        }
        //Է
        public string TestTry()
        {
            try
            {
                _sqlConnection = new SqlConnection();

                //code here to do something
            }
            finally
            {
                if (_sqlConnection != null)
                {
                    _sqlConnection.Dispose();
                    _sqlConnection = null;
                }
            }
            return "FrankClassWithUsing have already created  an new object...";
        }
        public string TestUsing()
        {
            using (_sqlConnection = new SqlConnection())
            {
                //code here to do something
            }
            return "FrankClassWithUsing have already created  an new object...";
        }
    }
   
}
